---
title: InputEvent.dataTransfer
slug: Web/API/InputEvent/dataTransfer
tags:
  - API
  - DOM Events
  - DataTransfer
  - Experimental
  - Input
  - InputEvent
  - Property
  - Reference
  - events
---
<p>{{APIRef("DOM Events")}}</p>

<p>The <strong><code>dataTransfer</code></strong> read-only property of the {{domxref("InputEvent")}} interface returns a {{domxref("DataTransfer")}} object containing information about richtext or plaintext data being added to or removed from editible content.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>dataTransfer</em> = <em>inputEvent</em>.dataTransfer</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DataTransfer")}} object.</p>

<h2 id="Examples">Examples</h2>

<p>In the following simple example we've set up an event listener on the <a href="/en-US/docs/Web/API/HTMLElement/input_event">input</a> event so that when any content is pasted into the contenteditable {{htmlelement("p")}} element, its HTML source is retrieved via the <code><a href="/en-US/docs/Web/API/DataTransfer/getData">InputEvent.dataTransfer.getData()</a></code> method and reported in the paragraph below the input.</p>

<p>Try copying and pasting some of the content provided to see the effects.</p>

<pre class="brush: html notranslate">&lt;p&gt;&lt;span style="font-weight: bold; color: blue"&gt;Whoa, bold blue text!&lt;/span&gt;&lt;/p&gt;
&lt;p&gt;&lt;span style="font-style: italic; color: red"&gt;Exciting: italic red text!&lt;/span&gt;&lt;/p&gt;
&lt;p&gt;Boring normal text ;-(&lt;/p&gt;

&lt;hr&gt;

&lt;p contenteditable="true"&gt;Go on, try pasting some content into this editable paragraph and see what happens!&lt;/p&gt;

&lt;p class="result"&gt;&lt;/p&gt;</pre>

<pre class="brush: js notranslate">var editable = document.querySelector('p[contenteditable]');
var result = document.querySelector('.result')
var dataTransferObj;

editable.addEventListener('input', (e) =&gt; {
  result.textContent = e.dataTransfer.getData('text/html');
});</pre>

<p>{{EmbedLiveSample('Examples', '100%', 250)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('InputEvents2','#dom-inputevent-datatransfer','dataTransfer')}}</td>
   <td>{{Spec2('InputEvents2')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.InputEvent.dataTransfer")}}</p>
</div>
